searchData={"items":[{"type":"task","title":"mix papertrail.install","doc":"generates paper_trail migration file for your database","ref":"Mix.Tasks.Papertrail.Install.html"},{"type":"function","title":"Mix.Tasks.Papertrail.Install.run/1","doc":"","ref":"Mix.Tasks.Papertrail.Install.html#run/1"},{"type":"behaviour","title":"PaperTrail","doc":"Provide functions to insert, update and delete records on the database alongside their changes.\n\n# Usage:\n\n```\ndefmodule MyApp.PaperTrail do\n  use PaperTrail,\n    repo: MyApp.Repo,\n    originator_type: Ecto.UUID,\n    item_type: Ecto.UUID\nend\n\ndefmodule MyApp.Context do\n  def create_user(params) do\n    changeset = MyApp.User.create_changeset(params)\n    # A `PaperTrail.Version` record with event `insert` is inserted\n    MyApp.PaperTrail.insert(changeset)\n  end\n\n  def update_user(user, params) do\n    changeset = MyApp.User.update_changeset(user, params)\n    # A `PaperTrail.Version` record with event `update` is inserted\n    MyApp.PaperTrail.update(changeset)\n  end\n\n  def delete_user(user) do\n    # A `PaperTrail.Version` record with event `delete` is inserted\n    MyApp.PaperTrail.delete(user)\n  end\nend","ref":"PaperTrail.html"},{"type":"function","title":"PaperTrail.add_prefix/2","doc":"","ref":"PaperTrail.html#add_prefix/2"},{"type":"function","title":"PaperTrail.delete/2","doc":"Deletes a record from the database with a related version insertion in one transaction","ref":"PaperTrail.html#delete/2"},{"type":"callback","title":"PaperTrail.delete/2","doc":"","ref":"PaperTrail.html#c:delete/2"},{"type":"function","title":"PaperTrail.delete!/2","doc":"Same as delete/2 but returns only the model struct or raises if the changeset is invalid.","ref":"PaperTrail.html#delete!/2"},{"type":"callback","title":"PaperTrail.delete!/2","doc":"","ref":"PaperTrail.html#c:delete!/2"},{"type":"callback","title":"PaperTrail.get_current_model/1","doc":"","ref":"PaperTrail.html#c:get_current_model/1"},{"type":"function","title":"PaperTrail.get_current_model/2","doc":"","ref":"PaperTrail.html#get_current_model/2"},{"type":"function","title":"PaperTrail.get_item_type/1","doc":"","ref":"PaperTrail.html#get_item_type/1"},{"type":"function","title":"PaperTrail.get_model_id/1","doc":"","ref":"PaperTrail.html#get_model_id/1"},{"type":"function","title":"PaperTrail.get_sequence_from_model/2","doc":"","ref":"PaperTrail.html#get_sequence_from_model/2"},{"type":"function","title":"PaperTrail.get_sequence_id/2","doc":"","ref":"PaperTrail.html#get_sequence_id/2"},{"type":"function","title":"PaperTrail.get_version/1","doc":"","ref":"PaperTrail.html#get_version/1"},{"type":"callback","title":"PaperTrail.get_version/1","doc":"","ref":"PaperTrail.html#c:get_version/1"},{"type":"function","title":"PaperTrail.get_version/2","doc":"","ref":"PaperTrail.html#get_version/2"},{"type":"callback","title":"PaperTrail.get_version/2","doc":"","ref":"PaperTrail.html#c:get_version/2"},{"type":"function","title":"PaperTrail.get_version/3","doc":"","ref":"PaperTrail.html#get_version/3"},{"type":"callback","title":"PaperTrail.get_version/3","doc":"","ref":"PaperTrail.html#c:get_version/3"},{"type":"function","title":"PaperTrail.get_versions/1","doc":"","ref":"PaperTrail.html#get_versions/1"},{"type":"callback","title":"PaperTrail.get_versions/1","doc":"","ref":"PaperTrail.html#c:get_versions/1"},{"type":"function","title":"PaperTrail.get_versions/2","doc":"","ref":"PaperTrail.html#get_versions/2"},{"type":"callback","title":"PaperTrail.get_versions/2","doc":"","ref":"PaperTrail.html#c:get_versions/2"},{"type":"function","title":"PaperTrail.get_versions/3","doc":"","ref":"PaperTrail.html#get_versions/3"},{"type":"callback","title":"PaperTrail.get_versions/3","doc":"","ref":"PaperTrail.html#c:get_versions/3"},{"type":"function","title":"PaperTrail.insert/2","doc":"Inserts a record to the database with a related version insertion in one transaction","ref":"PaperTrail.html#insert/2"},{"type":"callback","title":"PaperTrail.insert/2","doc":"","ref":"PaperTrail.html#c:insert/2"},{"type":"function","title":"PaperTrail.insert!/2","doc":"Same as insert/2 but returns only the model struct or raises if the changeset is invalid.","ref":"PaperTrail.html#insert!/2"},{"type":"callback","title":"PaperTrail.insert!/2","doc":"","ref":"PaperTrail.html#c:insert!/2"},{"type":"function","title":"PaperTrail.make_version_struct/3","doc":"","ref":"PaperTrail.html#make_version_struct/3"},{"type":"function","title":"PaperTrail.serialize/2","doc":"","ref":"PaperTrail.html#serialize/2"},{"type":"function","title":"PaperTrail.update/2","doc":"Updates a record from the database with a related version insertion in one transaction","ref":"PaperTrail.html#update/2"},{"type":"callback","title":"PaperTrail.update/2","doc":"","ref":"PaperTrail.html#c:update/2"},{"type":"function","title":"PaperTrail.update!/2","doc":"Same as update/2 but returns only the model struct or raises if the changeset is invalid.","ref":"PaperTrail.html#update!/2"},{"type":"callback","title":"PaperTrail.update!/2","doc":"","ref":"PaperTrail.html#c:update!/2"},{"type":"function","title":"PaperTrail.update_all/3","doc":"Updates all records from the database with a related version insertion in one transaction","ref":"PaperTrail.html#update_all/3"},{"type":"callback","title":"PaperTrail.update_all/3","doc":"","ref":"PaperTrail.html#c:update_all/3"},{"type":"type","title":"PaperTrail.all_result/0","doc":"","ref":"PaperTrail.html#t:all_result/0"},{"type":"type","title":"PaperTrail.meta/0","doc":"","ref":"PaperTrail.html#t:meta/0"},{"type":"type","title":"PaperTrail.multi_name/0","doc":"","ref":"PaperTrail.html#t:multi_name/0"},{"type":"type","title":"PaperTrail.options/0","doc":"","ref":"PaperTrail.html#t:options/0"},{"type":"type","title":"PaperTrail.origin/0","doc":"","ref":"PaperTrail.html#t:origin/0"},{"type":"type","title":"PaperTrail.originator/0","doc":"","ref":"PaperTrail.html#t:originator/0"},{"type":"type","title":"PaperTrail.prefix/0","doc":"","ref":"PaperTrail.html#t:prefix/0"},{"type":"type","title":"PaperTrail.queryable/0","doc":"","ref":"PaperTrail.html#t:queryable/0"},{"type":"type","title":"PaperTrail.repo/0","doc":"","ref":"PaperTrail.html#t:repo/0"},{"type":"type","title":"PaperTrail.result/0","doc":"","ref":"PaperTrail.html#t:result/0"},{"type":"type","title":"PaperTrail.strict_mode/0","doc":"","ref":"PaperTrail.html#t:strict_mode/0"},{"type":"type","title":"PaperTrail.updates/0","doc":"","ref":"PaperTrail.html#t:updates/0"},{"type":"module","title":"PaperTrail.Multi","doc":"Provide functions compatible with `Ecto.Multi` to insert, update and delete records on the database alongside their changes.","ref":"PaperTrail.Multi.html"},{"type":"function","title":"PaperTrail.Multi.add_prefix/2","doc":"","ref":"PaperTrail.Multi.html#add_prefix/2"},{"type":"function","title":"PaperTrail.Multi.append/2","doc":"","ref":"PaperTrail.Multi.html#append/2"},{"type":"function","title":"PaperTrail.Multi.commit/2","doc":"","ref":"PaperTrail.Multi.html#commit/2"},{"type":"function","title":"PaperTrail.Multi.delete/3","doc":"","ref":"PaperTrail.Multi.html#delete/3"},{"type":"function","title":"PaperTrail.Multi.error/3","doc":"","ref":"PaperTrail.Multi.html#error/3"},{"type":"function","title":"PaperTrail.Multi.get_item_type/1","doc":"","ref":"PaperTrail.Multi.html#get_item_type/1"},{"type":"function","title":"PaperTrail.Multi.get_model_id/1","doc":"","ref":"PaperTrail.Multi.html#get_model_id/1"},{"type":"function","title":"PaperTrail.Multi.get_sequence_from_model/2","doc":"","ref":"PaperTrail.Multi.html#get_sequence_from_model/2"},{"type":"function","title":"PaperTrail.Multi.get_sequence_id/2","doc":"","ref":"PaperTrail.Multi.html#get_sequence_id/2"},{"type":"function","title":"PaperTrail.Multi.insert/3","doc":"","ref":"PaperTrail.Multi.html#insert/3"},{"type":"function","title":"PaperTrail.Multi.make_version_struct/3","doc":"","ref":"PaperTrail.Multi.html#make_version_struct/3"},{"type":"function","title":"PaperTrail.Multi.make_version_structs/4","doc":"","ref":"PaperTrail.Multi.html#make_version_structs/4"},{"type":"function","title":"PaperTrail.Multi.merge/2","doc":"","ref":"PaperTrail.Multi.html#merge/2"},{"type":"function","title":"PaperTrail.Multi.merge/4","doc":"","ref":"PaperTrail.Multi.html#merge/4"},{"type":"function","title":"PaperTrail.Multi.new/0","doc":"","ref":"PaperTrail.Multi.html#new/0"},{"type":"function","title":"PaperTrail.Multi.prepend/2","doc":"","ref":"PaperTrail.Multi.html#prepend/2"},{"type":"function","title":"PaperTrail.Multi.run/3","doc":"","ref":"PaperTrail.Multi.html#run/3"},{"type":"function","title":"PaperTrail.Multi.run/5","doc":"","ref":"PaperTrail.Multi.html#run/5"},{"type":"function","title":"PaperTrail.Multi.serialize/2","doc":"","ref":"PaperTrail.Multi.html#serialize/2"},{"type":"function","title":"PaperTrail.Multi.to_list/1","doc":"","ref":"PaperTrail.Multi.html#to_list/1"},{"type":"function","title":"PaperTrail.Multi.update/3","doc":"","ref":"PaperTrail.Multi.html#update/3"},{"type":"function","title":"PaperTrail.Multi.update_all/4","doc":"","ref":"PaperTrail.Multi.html#update_all/4"},{"type":"type","title":"PaperTrail.Multi.changeset/0","doc":"","ref":"PaperTrail.Multi.html#t:changeset/0"},{"type":"type","title":"PaperTrail.Multi.multi/0","doc":"","ref":"PaperTrail.Multi.html#t:multi/0"},{"type":"type","title":"PaperTrail.Multi.options/0","doc":"","ref":"PaperTrail.Multi.html#t:options/0"},{"type":"type","title":"PaperTrail.Multi.queryable/0","doc":"","ref":"PaperTrail.Multi.html#t:queryable/0"},{"type":"type","title":"PaperTrail.Multi.result/0","doc":"","ref":"PaperTrail.Multi.html#t:result/0"},{"type":"type","title":"PaperTrail.Multi.struct_or_changeset/0","doc":"","ref":"PaperTrail.Multi.html#t:struct_or_changeset/0"},{"type":"type","title":"PaperTrail.Multi.updates/0","doc":"","ref":"PaperTrail.Multi.html#t:updates/0"},{"type":"module","title":"PaperTrail.Version","doc":"Ecto schema that represents a version of a record at a point of time.","ref":"PaperTrail.Version.html"},{"type":"function","title":"PaperTrail.Version.changeset/2","doc":"","ref":"PaperTrail.Version.html#changeset/2"},{"type":"function","title":"PaperTrail.Version.count/1","doc":"Returns the count of all version records in the database","ref":"PaperTrail.Version.html#count/1"},{"type":"function","title":"PaperTrail.Version.first/1","doc":"Returns the first version record in the database by :inserted_at","ref":"PaperTrail.Version.html#first/1"},{"type":"function","title":"PaperTrail.Version.last/1","doc":"Returns the last version record in the database by :inserted_at","ref":"PaperTrail.Version.html#last/1"},{"type":"type","title":"PaperTrail.Version.t/0","doc":"","ref":"PaperTrail.Version.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}